# Brute force prunning for transference learning in tensorflow


## What it is
Imagine that you want to perform object recognition, but for only two things: 
Blue Jays and Wolves. You could train a deep network yourself, but you would 
need a good amount of training data, some heavy computational resources, and 
some experience training deep networks, which can be tricky.

Or you could download [VGG's network, already trained](https://www.cs.toronto.edu/~frossard/post/vgg16/) and just use it.
But then you get a gigantic network, that includes way more information than 
you need for your specific problem. There is where this code comes in, where you
can prune the trained network, using just a few examples, to extract exactly
the parts necessary for your problem.

**Important remarks**:
* Brute force is slow
* Using this code requires a fair amount of knowledge of ML/tensorflow. It is not a black box.
* Only dense layers are considered (it should be easy to adapt to Conv. layers)
* Reduce one layer at a time. We don't consider the relationship between layers, 
results might be weird. Weight assigment probably doesn't work in this scenario.
* All software provided "as is". I'm not entirely sure that it will work for you.

## What is in the box
This repository includes 3 examples
1. [Abalone](https://archive.ics.uci.edu/ml/datasets/abalone): Classic ML dataset.
Hard problem, best accuracy I seen while testing was 36%. But it is small and it runs fairly quick
2. [MNIST](https://www.tensorflow.org/get_started/mnist/beginners): MNIST 
dataset already included in tensorflow. Fairly standard problem, easy to see 
that the network is too big for the problem. The included example considers only 
odd numbers and zero. 
3. [VGG](https://www.cs.toronto.edu/~frossard/post/vgg16/): Includes some code, 
but the actual weights need to be [downloaded](https://www.cs.toronto.edu/~frossard/post/vgg16/). 
Estimated time to run on a 1060: 10 days for the first layer, a couple of days 
for the others.

## How to use it:

1. Create a `model.py` file, including the functions:
    * `get_model(x,sess)`: Returns a **loaded** model, using placeholder x. Use sess to assign the values,
    * `get_new_model(x,sess)`: Same thing as `get_model`, but for the smaller model (you need this only for step 4),
    * `get_test()`: Returns (X,Y) for the accuracy computations,
    * `get_variables()`: Returns a list of variable names ('scope/var:0') to zero inputs,
2. Run `test.py` in the same folder. **This might take a while**.
3. Open `index.html`: it will read the file `data.json` generated by `test.py` 
so you can see where and how much to cut. One layer at a time.
4. Run `shrink.py`. Edit the file to save the new graph in a suitable way for your project (tf.saver - you can copy from abalone/train.py).
5. (optional) Make the "new" model the "old" model and run it again to shrink another layer.

**pro trick**: Copy the abalone folder and adapt it to your needs.

## How to interpret the visualization:

### MNIST
Lets consider the MNIST example, with two hidden layers with 256 nodes. This is 
a  rather large network for this problem.

![Mnist result](mnist.png)

The left panel shows the effect of removing a single input for each layer in the 
accuracy (using `get_test` data). In this case, most of the inputs are "meaningless": 
the removal of these inputs doesn't affect the accuracy. There are some important nodes,
that would affect the accuracy more deeply, but even then the result wouldn't change considerably.

The right panel is more interesting: it considers the sequential removal of 
inputs for each layer independently. Here is where the brute force enters: 
1. we remove the least impactful input,
2. Compute the accuracy for the removal of every other input independently
3. Back to 1 until there are no more inputs left

There are three guidelines:
* Green: No accuracy loss **for this data**,
* Orange: 5% loss,
* Red: 10% loss.

As we can see, for the considered data, these layer are too big, we can safely 
remove almost 200 nodes out of 256 without significant impact in the accuracy. 
While this network gets around 0.97 accuracy, an 8x8 can reach about 0.92 in my 
experience. Not a bad trade-off, if you have limited resources.


### abalone
Now the abalone example network, with three hidden layers, (64,64,32):

![Abalone result](abalone.png)

On the left panel, the nodes are much more evenly distributed, therefore the 
importance of each node to the final accuracy is greater, including nodes with 
more than 10% impact, for a 30% accuracy (1/3 drop). 
On the right panel, there are layers where any change will cause drastic drops 
in the accuracy, like the input layer, where the removal of any input (one of 
the 10 original variables) leads to a 5% loss.
However, the hidden layers are more "redundant", where we can remove almost 50 
of the 64 nodes with minimal impact.

**Important**: Keep in mind that these accuracies are computed **for the current
data** only! I strongly suggest considering a separate validation dataset to better
assess the accuracy of the new model.

## See also:
* https://arxiv.org/pdf/1611.06440.pdf
* http://icmlviz.github.io/papers/
* http://dl.acm.org/citation.cfm?id=3094262
* https://arxiv.org/abs/1701.04465
* https://github.com/handong1587